NsCDE 2.3 release notes
=======================
New and fixed in this release:

- Font and Color Style Manager: reload new themes without FVWM restart
- Qt6 integration support
- Optional Picom X Compositor internal support
- Thunderbird 102+ CSS theme integration support
- Firefox up to 113+ CSS theme integration support
- Font and Color Style Manager reshape, add integrations as separate dialog
- (De)Iconify X11 freeze glitch fvwm workaround
- Front Panel initial placement fix instead of workaround
- Fix GWM FvwmScript segfault on exit
- More missing icons in XDG icon theme
- Handle gsettings org.gnome.desktop.interface color-scheme
- Xscreensaver 6.X support
- Add detailed X resources for xcalc and some old Athena based apps
- Tuning X resources for more old apps
- Font and Color Style Manager: remember widget integration options
- GTK3 theme fixes: treat nasty header bar as toolbar
- Initial setup: add detailed integration questions, Qt6 support
- Front Panel clock: triangle hour and minute hands to match original
- GWMPager as popup on workspace change in no-page mode
- Fixed some easy-to-make keyboard shortcuts accidental calls
- Firefox and Thunderbird user.js additions for nice initial look & feel
- Thunderbird HTML compose window toolbar fix
- Docs update, many portability fixes, misc fixes, some typo fixes
- Portability and test phase fixes

NsCDE 2.2 release notes
=======================
This release add some features, 3rd party integrations, fixes bugs
etc. Highlights are:

- Add kcalc colors tom match dtcalc (colormgr.local)
- Fix rofi and dunst themes to work with new versions of programs
- NsCDE .desktop files renamed to conform to standards
- Front Panel on top of the screen possibility implemented. This
  can be achieved with "InfoStoreAdd frontpanel.on.top 1" in
  ~/.NsCDE/NsCDE.conf.
- Icon theme updates
- CSS: support firefox 100+
- Consolidate GTK2 and GTK3 engine css files, add some fixes
  and match colors more correctly
- Added Common User Access (CUA) key bindings. This is now
  default key binding set in NsCDE. Old key bindings scheme
  now called "nscde1x" can be used in ~/.NsCDE/NsCDE.conf
  with the "InfoStoreAdd kbd_bind_set nscde1x" - this can also
  be configured now with Keyboard Style Manager
- Keyboard Style Manager addons, Mouse Style Manager fixes
- Building: add --with-python-shebang="STRING" in configure
  to allow user to override strange alternatives managers on
  some systems
- Reorganize f_PolkitAgent to be more portable and stable
- Kvantum: Reshape in more Motif style Qt5 Combo Box
- More Firefox CSS updates
- Documentation updates for all of the above


NsCDE 2.1 release notes
=======================
This release fixes some glitches and bugs accumulated during the
transition from 1.X to 2.0, but it has also some new features:

- Qt5 widgets now have dinamically generated Kvantum engine
  which can be choosen in Color Style Manager as alternative to
  the gtk2 connector oriented engine. This works well, but
  glitches may still be expected even after tests with many
  Qt5 and modern KDE applications. It will improve during the
  time. It is perfectly usable.
- Key bindings set mechanism introduced. For now, there is only
  one set defined: default (nscde). This enabled NsCDE in future
  versions to implement standard key binding sets as IBM CUA
  standard or some other custom set.
- Color templates for Konsole and Qterminal - Qt5 based terminals
- New colormgr.local is simplified and can call functions from
  the <prefix>/share/NsCDE/config_templates/colormgr.addons.
- FVWM3: EwmhBaseStruts now follows Front Panel if it is moved
  across monitors.
- FVWM3: default root setter fvwm-root can be replaced by specifying
  InfoStore variable rootsetcmd in user's ~/.NsCDE/NsCDE.conf
- Sysinfo dialog now correctly displays NsCDE version after update
  and dynamic restart of FVWM.
- Initial bootstrap wizard backs up user's GUI widget configurations
  such as gtkrc and qt5ct.conf if they exist before changing them.
- Fix some polkit agents start/restart
- Updated documentation

See ChangeLog or "git log" for a complete list of changes.


NsCDE 2.0 release notes
=======================

This release is a turning point. All code and data is reorganized
to conform to the FHS standard. NsCDE now uses standard autoconf
and automake. Installation is universal weather started under
FVWM 2 or FVWM 3.

- Renamed most of the python and shell tools and helpers the are now
  located in libexec/NsCDE or lib/NsCDE depending on the system defaults
- Renamed FVWM configurations, stripped from unnecessary NsCDE- prefix
  new system of extensions indicated kind of file (see docs)
- Data, configs and commands completely reorganized to conform to FHS
  standard and be more suitable for packaging and system integration
- Made FVWM major version runtime detectable, there is no more
  separate installation parameters
- Added Front Panel Icon Manager application
- Added Front Panel context menu option to move launchers left or right
- Added Rename option to subpanels items context menu
- Introduced autoconf and automake for build and install process, no more
  Installer.ksh monster.
- Made RPM, Debian and Arch example packaging instructions and files
- Never ending CSS fixes for Firefox and Thunderbird as damaging of their
  look continues by the Mozilla
- 1.x to 2.x migration procedure introduced at 1st login to the NsCDE 2.0
  all data in ~/.NsCDE is renamed and key things renamed to work again
  old ~/.NsCDE is saved as tarball in user's home
- Context menus Help on Front Panel and Subpanels are now mostly content
  aware: they will display proper NsCDE documentation for NsCDE items
  and will try to find man pages for the rest applications, display them
  as HTML in browser, or directly if appropriate help reader is installed
- Uniformly rework and harden .desktop files in share/applications
- Smarter detection of XDG data and config paths during autoconf configure
- Huge documentation update, added more instructions, whole chapters,
  figures and illustrations with descriptions and examples
- bootstrap: add example Xset.conf and .xscreensaver if they are missing
- Fine tuned fontsets for larger resolutions
- Added more key bindings in FvwmScript applications
- Added more icons to icon theme to fix the missing gaps
- Front Panel button 8 now displays application manager instead of editor if
  compatible file manager capable of doing it is found
- Front Panel position can be now configured in ~/.NsCDE.conf
- Update locale
- Added more 3rd party integrations in config_templates/colormgr.local
- Enhance confit_templates/fontmgr.local with new examples, install it
  during bootstrap procedure
- Really fix and test font sync to qt5ct.conf
- Correct screen calculation for GWM under FVWM3 in multi monitor mode
- Correct screen calculation for GWMPager under FVWM3 in multi monitor mode
- Fixed internal non-fatal syntax errors in WSM
- Minor typo and bug fixes which were found during the process of FHS-ing

See ChangeLog or "git log" for a complete list of changes.


NsCDE 1.4 release notes
=======================

This release contains minor and cosmetic fixes. It is the last of the
1.x series. New one will be 2.0.

- Firefox and Thunderbird CSS fixes and updates
- Fixed some hardcoded paths
- FpLite to AppFinder for more autodetection hits
- Typos in some backdrops XPM fixed
- OSD colors for some volume managers in GTK theme fixed
- Minor syntax error bug in WSM fixed
- CheckMailApplet consolidated functionality
- Added some icons and icon symlinks in icon theme
- Some X resources fixes in Color Style Manager templates
- NProcmgr popup refresh fix
- Fix IconSize calculations of WindowMgr
- Fix missing comma in NsCDE-Style.conf near IconFill
- Fix docs for exec/rofi keybinding
- Fix StyleMgr Help Menu distance on some systems


NsCDE 1.3 release notes
=======================

This release contains improvements, bugfixes and new features.
New additions are:

- Graphical Workspace Manager (GWM) as on Solaris CDE (call it with
  Meta+Alt+Home)
- GWM and GlobalPager configuration is now autogenerated and controled
  from WSM.conf. GlobalPager is now GWMPager
- CSS templates for NsCDE/CDE integration of the Firefox 7x, 8x and 9x
- CSS templates for NsCDE/CDE integration of the Thunderbird
- Remember reboot/shutdown/suspend/logout actions
- FVWM per-monitor and share multi monitor mode different backdrops on
  different monitors support
- Occupy Workspace and Page has now 3rd mode of operation: Monitor
- Configurable LocalPager and GlobalPager dissapear timeout in NscDE.conf
- Style Manager now includes icon for Workspaces and Pages Style Manager
- Added optonal screenshot of screen or screen area if xclip is installed
- Cleaned Front Panel Subpanels
- More default app and MIME support added

Apart from new features and additions, there are some first setup, Workspace
Manager hardenings, which enabled proper initial locale setting of workspace
names, and does not depend on existance of WSP entries in WSM.conf.

See ChangeLog or "git log" for a complete list of changes.


NsCDE 1.2 release notes
=======================

This is a bugfix release of NsCDE without major new features or
changes. For a time this will probably be long term release until
new cycle of planned changes and works begins. Lot of fixes which
emerged from usage and from GitHub issue reports, also there is
some optimizations and polishing on many places.

See ChangeLog or "git log" for a list of changes.


NsCDE 1.1 release notes
=======================

This is the first "real" release, after 2 years of development.
Release focuses on this major points:

- Better wallpaper handling in Backdrop Style Manager
- FVWM3 used by default when found (if not overriden by explicit environment)
- Keybindings has been further logically reorganized
- Manual Tiling support with Meta+Alt+R
- Documentation update
- Portability: NetBSD, OpenIndiana, OpenBSD, DragonFly BSD

1. New features

- Wallpapers can now be centered, tiled or aspect-stretched in the Backdrop
  Style Manager

- Windows of the current page can be tiled with Meta+Alt+R, and resized in
  semi-automatic zoom in and zoom out mode with Meta+F4 and Shift+Meta+F4

- NsCDE has been tested, tuned and fixed to run on NetBSD, OpenIndiana,
  OpenBSD, and DragonFly BSD. With Linux and FreeBSD support, this covers
  pretty much all of active free, open and semi-free UNIX and Linux systems

- Key bindings are ordered to use Meta, Alt, Meta+Alt, Menu, Escape and
  Tab in conditions where appropriate, hintful and logical. For example,
  Menu key based keybindings are for actions about menus. Window movement
  iconification, size, closing, repositioning actions are bounded to F
  buttons with similar actions on the same F button, but with Alt or Meta
  as the modifier


2. Bug fixes

- See ChangeLog or "git log" for detailed working list of fixes. Generally
  most of the fixes are working same-day fixes, but there was some old
  findings.


3. Removed / discontinued

- NsCDE-photos git repo is discontinued and will be removed in the future.
  With NsCDE there are now coming four file size optimized PNG examples.
  All other wallpapers, if wanted instead of backdrops, should be provided
  by the user in $FVWM_USERDIR/photos manually, or imported with "Add ..."
  button from Backdrop Style Manager


4. Misc

- Two years ago, NsCDE has started as consolidation of chaotic private set
  of fvwm configurations and scripts. Spontaneously, this emerged as
  something which can be shared by others, and in march of 2019 uploaded
  as project on GitHub. Since then, lot of features and fixes appeared
  and active development has beed made on betas, and then long never ending
  row of release candindates up to rc28. This is now the first release.
  Since most of the release candidates were really 1.0 already. The first
  real release will take version 1.1. After it, 1.2 will emerge and so on ...


NsCDE 1.0rc28 (pre)release notes
================================

This pre-release focuses on 5 major points:

- FVWM3 support
- Menus and keybinding ergonomic reworked for usability as well as CDE
  similarity where applicable and useful
- Front Panel color 8 and colored WSM options support, which covers a wide
  range of CDE variants on old UNIX systems
- Reworked OccupyWorkspace/Page dialog for extended usability
- General polishing and fixing for release 1.1 which should happen in the
  middle of december 2020 on the 2th anniversary of starting work on NsCDE

1. New features

- Color Style Manager in "Number Of Colors ..." dialog now offers two new
  (sub)options: to use color 8 of the palette for icon background on Front
  Panel and interior Icon background as on some versions of CDE on HP-UX
  and AIX. Further, some versions of UNIX systems had Workspace Manager in
  the color 6 of the palette, which is also offered as an option in NsCDE
  now. Both of this features are available only in 8-colors mode, not in
  4-colors. Because of necessary internal changes, (Colorset 23 addition)
  $FVWM_USERDIR/NsCDE-Colorset.conf must be rebuilt. After upgrade, Color
  Style Manager and popup message with that info will appear on screen
  after upgrade from pre-1.0rc28 and (re)start of FVWM. Select existing
  or any other color scheme to get Front Panel properly colored again.

- Icons can now be focused and browsed with up/down arrows on the one page
  with Meta+Alt+i. Pressing Meta+Alt+i selects back last non-iconic window on
  the current workspace/page.

- Smooth use with FVWM3 as much as this can be, during this still "young"
  phase of FVWM3. On system with both FVWM2 and FVWM3 installed, FVWM2 will
  still be used by default, but this can be overriden by putting FVWM_BIN
  variable in startup or login profile to point to main FVWM2 or FVWM3 binary.

- Occupy Workspace and Occupy Page dialogs has been merged into one app. When
  called as "Occupy Workspace" initial behaviour and list is workspaces, and
  when called as "Occupy Page" initially list of pages will be shown. By
  pressing workspace or page radio button, or space key shortcut, mode of
  operation will switch from pages to workspaces and vice versa. In short,
  it is enough to call Occupy to select workspace and page in one move.

- Window Operations Menu can be now called with Meta+Alt+Space or Meta+Alt+m.

- CDE Alt+ArrowUp and Alt+ArrowDown raise/lower overlapping windows support.

- Flipping windows on the current workspace/page with Ctrl+Menu and
  Ctrl+ISO_Level3_Shift

- Icon placement now in pixels matches CDE placement of iconified windows.

- Menus are now logical and consolidated. Specially Window Operations Menu.
  There are no dead or non-usable options presented. Dynamic menus are used.
  This is now tuned also for the Front Panel and Subpanels menus.

- It should be possible now to work with keyboard without touching mouse in
  the most cases.

- New logo based on brutalism achitecture style and patterns, which nicely
  fits general CDE and NsCDE experience.

- nscde_setup wizard now supports localization.

- Select Area screenshot option


2. Bug fixes

   - See ChangeLog or "git log" for detailed working list of fixes. Generally
     most of the fixes are working same-day fixes, but there was some old
     findings.


3. Removed / discontinued

   - Removed old logo, removed some faulty and wrong backdrops and the rest
     consolidated. Removed duplicate and very similar palettes from some old
     non-standard CDE palettes collection.

   - OccupyWorkspace and OccupyPage dialogs are replaced with unified Occupy
     dialog.


4. Misc

   - Backdrops were consolidated, named logically from their ad hoc choosen
     names, palettes were also consolidated with duplicates and almost
     duplicates removed.

   - New TallSkyDark and TallSkyLight backdrops for moden big displays.
     Diethering of course remains.

   - First mouse button click on the root window now gives root menu, not
     double click. Double click will give Window Options menu.


NsCDE 1.0rc25 (pre)release notes
================================

- NsCDE 1.0rc25 release

- Fix nasty stopper in Installer.ksh which misconfigures NSCDE_ROOT in interactive setup.

- Reworked the way "Version" builtin variable is used in FVWM configuration, it will go
  away in FVWM3.

- Added checks on the basis FVWM_IS_FVWM3 environmnent variable to functions,
  Sysinfo and Splash. This is not yes full FVWM3 support.


NsCDE 1.0rc24 (pre)release notes
================================

Two and half months after 1.0rc22 prerelease, new release candidate again has
extended functionality of the NsCDE. There will be no more new functionalities
before 1.1 release, just couple of months for fixing and polishing existing
code. NsCDE 1.1 (1.0 was actually long ago), will be released probably in
december, on the day when all started 2 years ago.

Here are the highlights of what has changed and what is added between 1.0rc22
and 1.0rc24

1. New Apps and Features

- NProcMgr: NsCDE Process Manager: application which shows NsCDE FVWM and
  other processes, their pids and running/presence state. Processes can be
  started, stopped and restarted. It also has capabilities for rereading
  various parts of the configuration: Menus, Functions, Style, Keybindings
  etc. NsCDE Process Manager is present by default on the Desktop Settings
  submenu (7) of the Front Panel, but it can also be found on the Workspace
  Menu NsCDE submenu, as well as from Watch Errors and Fvwm Console contextual
  part of the Window Options Menu.

- GeometryMgr: Before 1.0rc22, "Save Geometry" option on the Window Options
  Menu or Meta+F6 directly called function which saved current window
  geometry, so windows will be positioned and sized on exact geometry
  coordinates next time when they appear on the page and workspace for the
  first time, or with "Reposition Window" option of the Window Options Menu.
  Needles to say, this option was easy to catch with mouse by mistake, and
  even more with key binding.
  New FvwmScript application brings dialog with window class and resource
  names, and exact coordinates when Save Geometry is called, plus info about
  previous remembered pixel size and position if any. Here, user can inspect,
  tune, cancel or confirm that new saving. Clearing all values and choosing
  save clears that and any before existing geometry mapping for that screen
  resolution.

- Custom Front Panel Launchers: from the beginning until now, Front Panel
  had fixed number of launchers (big icon or applet plus optional submenu)
  on the left and right side of the Workspace Manager. Now, with a usage of
  Front Panel Controls menu and it's "Number of Launchers ..." submenu, user
  can reduce to 0, or extend to 20 number of launchers. As in CDE, default
  is 10 launchers (5 left, and 5 right), which gives 10. This can be doubled
  or reduced to 4, 3, 2, 1 or no launchers at all. This allows user to make
  configurations with Workspace Manager leftmost or rightmost on the Front
  Panel, to make minimal only Workspace Manager plus handlers Front Panel
  without launchers, or to make really wide Front Panels with 18, 19 and
  with maximum 20 launchers (screen resolution must support such stretching
  of the Front Panel). All new custom launchers can be customized to contain
  icons or applets, to have or not subpanels.

- Wide or Eco Workspace Manager: together with custom launchers on the Front
  Panel, Workspace Manager (WSM) now by default has fixed width of workspace
  buttons. This means that shrinking workspace to 2 workspaces will shrink
  Front Panel, and expanding workspaces to 6 or 8 will expand it. This is
  in contrast to fixed WSM on which until now the buttons themselves where
  shrinked (6, 8) or expanded (2), but WSM frame remained of the same width.
  New behaviour is in sync with visual CDE behaviour and gives a chance for
  wider workspace names in 6  or 8 workspaces mode. Old fixed width WSM can
  be used if InfoStore variable wsm.eco is defined and set to 1 in
  $FVWM_USERDIR/NsCDE.conf

- Splash screen: NsCDE has now splash screen on startup. It displays logo,
  information about system on which it is running, NsCDE and FVWM version,
  licence and such. It lasts some 6 seconds on start, but can be speed up
  with Control+C or by clicking on the text.

- Show Workspace functionality: called by the Root Menu as "Clean/Restore
  Workspace", by Ctrl + Left click on the root window and with Meta+Alt+W
  keybinding. It will iconify all windows on the page or restore them on
  subsequent calls. Already iconified windows prior to calling this function,
  as well as newly opened windows on the page will not be affected by this
  group iconify / deiconify (show desktop) action. During this action, any
  animation which may be configured with Window Style Manager for FvwmAnimate
  will be temporary disabled to avoid long dance on the screen if there are
  many windows on it.

- New keybindings:
  - Meta+Shift+Tab will cycle workspaces backwards.
  - Meta+Alt+W calls Show Desktop

- Dunst support: A nice FVWM-friendly notification daemon dunst(1) is probably
  the best choice for custom DE environments and classis Window Managers. It
  is now tightly integrated with NsCDE in the same was as stalonetray: it can
  be enabled or disabled with InfoStore variable nscde_use_dunst 0/1 in user's
  $FVWM_USERDIR/NsCDE.conf. Configuration is provided and partially managed
  (Color Style Manager and Font Style Manager) by the NsCDE as
  $FVWM_USERDIR/Dunst.conf
  This means that handling of dunst(1) and stalonetray(1) can be removed from
  $FVWM_USERDIR/libexec/colormgr.local, because this is now handled
  internally.

- New Palettes and Backdrops:
  - palettes: LateSummer
  - backdrops: CubesSmall and Pearls

- Merge of the VUE Palettes and Backdrops: there is no need to install this as
  addon. It is merged with other palettes and backdrops, because it is fully
  compatible, no matter that this comes from pre-CDE era.

- New finder for Audio Volume Control application: gives it's best to find
  working audio mixer app on the subpanel of launcher 9 on the Front Panel.

- Installer.ksh: support staged installation (for packaging) with -D


2. Bug fixes

- Fix possible indefinite Wait in share/config_templates/NsCDE-Functions.local sample

- Fix WSM truncating WSM.conf bug after initial creation before first restart

- Style fixes for Gkrellm, Sysinfo, menus etc ...

- Removed xscreensaver splash

- Iconify Event function fix when PipeRead gets dash(1) shell on Debian, which is
  aliased to /bin/sh (called by the system()) users will not have '=' and '60' empty
  files in their homedir anymore.

- Better error handling for sysinfo.py (Workstation Information)

- Python syntax fixes (warnings noticed on Debian)

- Major works on higher DPI corrections for font handling

- Localization fixes

- Fix Splash Screen under fvwm3 (hopefully) on multi display

- Fixes for monitor enumeration, preparations for FVWM3 support

- Fix default Front Panel Iconified IconBox position not to overlap stalonetray


3. Removed / discontinued

- Stop using FvwmBanner (removed in FVWM3) - we have Splash now

- Removed Black.dp, BlackWhite.dp and White.dp obsolete nonworking palettes


4. Misc

- Documentation revision and update, new sections and corrections

- Consolidated Delete/Close/Destroy Window Options menu actions

- Front Panel Controls menu consolidation and help

- Add Solaris Earth Watch icon in the icon set, document example how to use it
  on the Front Panel as a custom applet.

- Init and setup procedure polishing

